    {

 : RECUNIT.PAS  V 1.01
:  19 1996  21:56  IBM ThinkPad
 #7:  22 1997, 15:01  IBM ThinkPad
-John Mertus


       .


 1.00 -  
1.01 -  TWaveInGetErrorText
}


{-----------------Unit-RECUNIT---------------------John Mertus--- 96---}


Unit RECUNIT;


{*************************************************************************}

Interface

Uses
  Windows,
  MMSystem,
  MSACM;

{     TWaveRecorder        }
{  . ,       TWaveRecorder  }
{    TWaveRecorder.ProcessBuffer.       }
{          -.    }

Const
  MAX_BUFFERS = 8;

type
  PWaveRecorder = ^TWaveRecorder;
  TWaveRecorder = class(TObject)
    Constructor Create(BfSize, TotalBuffers : Integer);
    Destructor  Destroy; Override;
    Procedure   ProcessBuffer(uMsg : Word; P : Pointer; n : Integer; dwParam1: dword); Virtual;
    private
      fBufferSize        : Integer;          //  
      BufIndex           : Integer;
      fTotalBuffers      : Integer;
      pWaveHeader        : Array [0..MAX_BUFFERS-1] of PWAVEHDR;
      hWaveHeader        : Array [0..MAX_BUFFERS-1] of THANDLE;
      hWaveBuffer        : Array [0..MAX_BUFFERS-1] of THANDLE;
      hWaveFmtEx         : THANDLE;
      dwByteDataSize     : DWORD;
      dwTotalWaveSize    : DWORD;
      RecordActive       : Boolean;
      bDeviceOpen        : Boolean;
{    }
      Function InitWaveHeaders : Boolean;
      Function AllocPCMBuffers : Boolean;
      Procedure FreePCMBuffers;
      Function AllocWaveFormatEx : Boolean;
      Procedure FreeWaveFormatEx;
      Function AllocWaveHeaders : Boolean;
      Procedure FreeWaveHeader;
      Function AddNextBuffer : Boolean;
      Procedure CloseWaveDeviceRecord;
    public
{ Public declarations }
      pWaveFmtEx         : PWaveFormatEx;
      WaveBufSize        : Integer;          //   nBlockAlign
      InitWaveRecorder   : Boolean;
      RecErrorMessage    : String;
      QueuedBuffers,
      ProcessedBuffers   : Integer;
      pWaveBuffer        : Array [0..MAX_BUFFERS-1] of lpstr;
      WaveIn             : HWAVEIN; {  Wav- }
      Procedure StopRecord;
      Function StartRecord : Boolean;
      Function SetupRecord(P : PWaveRecorder) : Boolean;
  end;

{*************************************************************************}

implementation

{-------------TWaveInGetErrorText-----------John Mertus---14---97--}

Function TWaveInGetErrorText(iErr : Integer) : String;

{     WaveIn   Pascal                  }
{ iErr -                                                    }
{                                                                      }
{**********************************************************************}
Var
  PlayInErrorMsgC: Array [0..255] of Char;
begin
  WaveInGetErrorText(iErr, PlayInErrorMsgC, 255);
  TWaveInGetErrorText:= PlayInErrorMsgC;
end;

{-------------InitWaveHeaders---------------John Mertus---14---97--}

Function TWaveRecorder.AllocWaveFormatEx : Boolean;

{    ,    ACM-}
{                                                                      }
{**********************************************************************}
Var
  MaxFmtSize: UINT;
begin
{ maxFmtSize -  sizeof(WAVEFORMATEX) + pwavefmtex.cbSize }
  If( acmMetrics( 0, ACM_METRIC_MAX_SIZE_FORMAT, maxFmtSize ) <> 0) Then
  Begin
    RecErrorMessage := '     ';
    AllocWaveFormatEx := False;
    Exit;
  end;
{   WAVEFMTEX }
  hWaveFmtEx := GlobalAlloc(GMEM_MOVEABLE, maxFmtSize);
  If (hWaveFmtEx = 0) Then
  Begin
    RecErrorMessage := '     WaveFormatEx';
    AllocWaveFormatEx := False;
    Exit;
  End;
  pWaveFmtEx := PWaveFormatEx(GlobalLock(hWaveFmtEx));
  If (pWaveFmtEx = Nil) Then
  Begin
    RecErrorMessage := '   WaveFormatEx';
    AllocWaveFormatEx := False;
    Exit;
  End;
{     PCM }
  ZeroMemory( pwavefmtex, maxFmtSize );
  pwavefmtex.wFormatTag := WAVE_FORMAT_PCM;
  pwavefmtex.nChannels := 1;
  pwavefmtex.nSamplesPerSec := 20000;
  pwavefmtex.nBlockAlign := 1;
  pwavefmtex.wBitsPerSample := 16;
  pwavefmtex.nAvgBytesPerSec := pwavefmtex.nSamplesPerSec*
                                (pwavefmtex.wBitsPerSample div 8)*pwavefmtex.nChannels;
  pwavefmtex.cbSize := 0;
{  ,   }
  AllocWaveFormatEx := True;
end;

{-------------InitWaveHeaders---------------John Mertus---14---97--}

Function TWaveRecorder.InitWaveHeaders : Boolean;

{  ,   wave          }
{                                                                      }
{**********************************************************************}
Var
  i: Integer;
begin
{      ... }
  WaveBufSize := fBufferSize - (fBufferSize mod pwavefmtex.nBlockAlign);
{  wave- }
  For i := 0 to fTotalBuffers-1 Do
  With pWaveHeader[i]^ Do
  begin
    lpData := pWaveBuffer[i];      //   waveform
    dwBufferLength := WaveBufSize; // ,  , 
    dwBytesRecorded := 0;          //  
    dwUser := 0;                   // 32   
    dwFlags := 0;                  //  
    dwLoops := 0;                  //  
    lpNext := Nil;                 // ;   
    reserved := 0;                 // ;   
  end;
  InitWaveHeaders := TRUE;
end;


{-------------AllocWaveHeader----------------John Mertus---14---97--}


Function TWaveRecorder.AllocWaveHeaders : Boolean;

{                                  }
{                                                                       }
{***********************************************************************}
Var
  i: Integer;
begin
  For i := 0 to fTotalBuffers-1 Do
  begin
    hwaveheader[i]:= GlobalAlloc(GMEM_MOVEABLE or
                                 GMEM_SHARE or
                                 GMEM_ZEROINIT,
                                 sizeof(TWAVEHDR));

    if (hwaveheader[i] = 0) Then
    begin
{ :      ,    }
      RecErrorMessage := '    wave-';
      AllocWaveHeaders := FALSE;
      Exit;
    end;
    pwaveheader[i] := GlobalLock (hwaveheader[i]);
    If (pwaveheader[i] = Nil ) Then
    begin
{ :      ,    }
      RecErrorMessage := '      ';
      AllocWaveHeaders := FALSE;
      Exit;
    end;
  End;
  AllocWaveHeaders := TRUE;
end;

{---------------FreeWaveHeader---------------John Mertus---14---97--}

Procedure TWaveRecorder.FreeWaveHeader;

{    AllocWaveHeaders .            }
{                                                                       }
{***********************************************************************}
Var
  i: Integer;
begin
  For i := 0 to fTotalBuffers-1 Do
  begin
    If (hWaveHeader[i] <> 0) Then
    Begin
      GlobalUnlock(hwaveheader[i]);
      GlobalFree(hwaveheader[i]);
      hWaveHeader[i] := 0;
    End
  end;
END;

{-------------AllocPCMBuffers----------------John Mertus---14---97--}

Function TWaveRecorder.AllocPCMBuffers : Boolean;

{     waveform.                             }
{                                                                       }
{***********************************************************************}
Var
  i: Integer;
begin
  For i := 0 to fTotalBuffers-1 Do
  begin
    hWaveBuffer[i] := GlobalAlloc( GMEM_MOVEABLE or GMEM_SHARE, fBufferSize );
    If (hWaveBuffer[i] = 0) Then
    begin
{     }
      RecErrorMessage := '   wave-';
      AllocPCMBuffers := False;
      Exit;
    end;
    pWaveBuffer[i] := GlobalLock(hWaveBuffer[i]);
    If (pWaveBuffer[i] = Nil) Then
    begin
{     }
      RecErrorMessage := '   wave-';
      AllocPCMBuffers := False;
      Exit;
    end;
    pWaveHeader[i].lpData := pWaveBuffer[i];
  End;
  AllocPCMBuffers := TRUE;
end;

{--------------FreePCMBuffers----------------John Mertus---14---97--}

Procedure TWaveRecorder.FreePCMBuffers;

{   AllocPCMBuffers .                    }
{                                                                       }
{***********************************************************************}
Var
  i: Integer;
begin
  For i := 0 to fTotalBuffers-1 Do
  begin
    If (hWaveBuffer[i] <> 0) Then
    Begin
      GlobalUnlock( hWaveBuffer[i] );
      GlobalFree( hWaveBuffer[i] );
      hWaveBuffer[i] := 0;
      pWaveBuffer[i] := Nil;
    End;
  end;
END;

{--------------FreeWaveFormatEx--------------John Mertus---14---97--}

Procedure TWaveRecorder.FreeWaveFormatEx;

{    ExFormat headers                         }
{                                                                       }
{***********************************************************************}
begin
  If (pWaveFmtEx = Nil) Then Exit;
  GlobalUnlock(hWaveFmtEx);
  GlobalFree(hWaveFmtEx);
  pWaveFmtEx := Nil;
end;

{-------------TWaveRecorder.Create------------John Mertus-------97--}

Constructor TWaveRecorder.Create(BFSize, TotalBuffers : Integer);

{  wave-,          }
{                                      }
{ BFSize -                                          }
{                                                                      }
{**********************************************************************}
Var
  i: Integer;
begin
  Inherited Create;
  For i := 0 to fTotalBuffers-1 Do
  Begin
    hWaveHeader[i] := 0;
    hWaveBuffer[i] := 0;
    pWaveBuffer[i] := Nil;
    pWaveFmtEx := Nil;
  End;
  fBufferSize := BFSize;
  fTotalBuffers := TotalBuffers;
{     wave- }
  If(Not AllocWaveFormatEx) Then
  Begin
    InitWaveRecorder := FALSE;
    Exit;
  End;
{  ,    wave- }
  If (waveInGetNumDevs < 1 ) Then
  Begin
    RecErrorMessage := '  ,   ';
    InitWaveRecorder := FALSE;
    Exit;
  End;
{   wave- }
  If (Not AllocWaveHeaders) Then
  Begin
    InitWaveRecorder := FALSE;
    Exit;
  End;
{    wave- }
  If (Not AllocPCMBuffers)  Then
  Begin
    InitWaveRecorder := FALSE;
    Exit;
  End;
  InitWaveRecorder := TRUE;
end;

{---------------------Destroy----------------John Mertus---14---97--}

Destructor TWaveRecorder.Destroy;

{    ,  InitWaveRecorder.       }
{                                                                       }
{***********************************************************************}

begin
  FreeWaveFormatEx;
  FreePCMBuffers;
  FreeWaveHeader;
  Inherited Destroy;
end;

{------------CloseWaveDeviceRecord-----------John Mertus---14---97--}

Procedure TWaveRecorder.CloseWaveDeviceRecord;

{   () waveform-.                   }
{                                                                       }
{***********************************************************************}
Var
  i: Integer;
begin
{    ,   }
  If (Not bDeviceOpen) Then Exit;
{    - unprepare }
  For i := 0 to fTotalBuffers-1 Do
    If (waveInUnprepareHeader(WaveIn, pWaveHeader[i], sizeof(TWAVEHDR)) <> 0 )
    Then RecErrorMessage := '  waveInUnprepareHeader';
{        }
  dwTotalwavesize := dwBytedatasize;
{   wave- }
  If (waveInClose(WaveIn) <> 0)
  Then RecErrorMessage := '   ';
{   ,    }
  bDeviceOpen := FALSE;
end;

{------------------StopRecord-----------------John Mertus---14---97--}

Procedure TWaveRecorder.StopRecord;

{      .                 }
{                                                                       }
{***********************************************************************}
Var
  iErr: Integer;
begin
  RecordActive := False;
  iErr := waveInReset(WaveIn);
{         }
  If (iErr <> 0) Then RecErrorMessage := '  waveInReset';
  CloseWaveDeviceRecord;
end;

{--------------AddNextBuffer------------------John Mertus---14---97--}

Function TWaveRecorder.AddNextBuffer : Boolean;

{         .     }
{                                                                       }
{***********************************************************************}
Var
  iErr: Integer;
begin
{          }
  iErr := waveInAddBuffer(WaveIn, pwaveheader[bufindex], sizeof(TWAVEHDR));
  If (iErr <> 0) Then
  begin
    StopRecord;
    RecErrorMessage := '  ' + TWaveInGetErrorText(iErr);
    AddNextBuffer := FALSE;
    Exit;
  end;
{     }
  bufindex := (bufindex+1) mod fTotalBuffers;
  QueuedBuffers := QueuedBuffers + 1;
  AddNextBuffer := TRUE;
end;

{--------------BufferDoneCallBack------------John Mertus---14---97--}

Procedure BufferDoneCallBack(
  hW    : HWAVE;      //  waveform-
  uMsg  : DWORD;      //  
  dwInstance : DWORD; //  
  dwParam1 : DWORD;   //   
  dwParam2 : DWORD   //   
  ); stdcall;

{     wave- - ,       }
{                                            }
{                                                                       }
{***********************************************************************}
Var
  BaseRecorder: PWaveRecorder;
begin
  BaseRecorder := Pointer(DwInstance);
  With BaseRecorder^ Do
  Begin
    ProcessBuffer(uMsg, pWaveBuffer[ProcessedBuffers Mod fTotalBuffers],
    WaveBufSize, dwParam1);
    If (RecordActive) Then
    Case uMsg of
      WIM_DATA:
      Begin
        BaseRecorder.AddNextBuffer;
        ProcessedBuffers := ProcessedBuffers+1;
      End;
    End;
  End;
end;

{------------------StartRecord---------------John Mertus---14---97--}

Function TWaveRecorder.StartRecord : Boolean;

{  .                                                        }
{                                                                       }
{***********************************************************************}
Var
  iErr: integer;
  i:    Integer;
begin
{      }
  iErr := WaveInStart(WaveIn);
  If (iErr <> 0) Then
  begin
    CloseWaveDeviceRecord;
    RecErrorMessage := '   wave: ' +
    TWaveInGetErrorText(iErr);
  end;
  RecordActive := TRUE;
{      }
  For i := 1 to fTotalBuffers-1 Do
  If (Not AddNextBuffer) Then
  Begin
    StartRecord := FALSE;
    Exit;
  End;
  StartRecord := True;
end;

{-----------------SetupRecord---------------John Mertus---14---97--}


Function TWaveRecorder.SetupRecord(P : PWaveRecorder) : Boolean;

{        waveform-"". }
{                                                                       }
{***********************************************************************}
Var
  iErr: integer;
  i:    Integer;
begin
  dwTotalwavesize := 0;
  dwBytedatasize := 0;
  bufindex := 0;
  ProcessedBuffers := 0;
  QueuedBuffers := 0;
{     }
  iErr := waveInOpen(@WaveIn, WAVE_MAPPER, pWaveFmtEx,
  Integer(@BufferDoneCallBack),
  Integer(P), CALLBACK_FUNCTION + WAVE_ALLOWSYNC );
  If (iErr <> 0) Then
  Begin
   RecErrorMessage := '      : ' + ^M +
                      TWaveInGetErrorText(iErr);
   SetupRecord := FALSE;
   Exit;
  End;
{  CloseWaveDeviceRecord(),    }
  bDeviceOpen := TRUE;
{   }
  InitWaveHeaders();
  For i := 0 to fTotalBuffers-1 Do
  Begin
    iErr := waveInPrepareHeader( WaveIn, pWaveHeader[I], sizeof(TWAVEHDR));
    If (iErr <> 0) Then
    begin
      CloseWaveDeviceRecord;
      RecErrorMessage := '    : ' + ^M +
      TWaveInGetErrorText(iErr);
      SetupRecord := FALSE;
      Exit;
    end;
  End;
{    }
  If (Not AddNextBuffer) Then
  begin
    SetupRecord := FALSE;
    Exit;
  end;
  SetupRecord := TRUE;
end;

{-----------------ProcessBuffer---------------John Mertus---14---97--}

Procedure   TWaveRecorder.ProcessBuffer(uMsg: Word; P : Pointer; n :Integer; dwParam1: dword);

{  ,    .                 }
{                                                                       }
{***********************************************************************}
begin
end;

end.
